// ## Static OKit_Bltn Definition
// DEFINE BRK
// INTERN Break


NEWBLTN(_InstDef_Break) ;


static const _OKit_Bltn _BltnDef_Break = 
	{ "BRK",    1, { 8    }, ~0, _InstDef_Break,       "Breaks a compound object" } ;


NEWBLTN(_InstDef_Break) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	unsigned long l = 0 ;
	unsigned long i = 0 ;
	OKit_List lst ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		lst = (OKit_List)obj1->obj ;
		l = OKit_ListLen(lst) ;
		while(i<l) {
			obj = OKit_ListGet(lst,i) ;
			if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
			if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
			i ++ ;
		}
		obj = OKit_IntgWrap(OKit_IntgNew(l)) ;
		if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
		if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


