// ## Static OKit_Bltn Definition
// DEFINE CAT
// INTERN Cat


NEWBLTN(_InstDef_Cat) ;


static const _OKit_Bltn _BltnDef_Cat = 
	{ "CAT",    2, { 8, 8 },  1, _InstDef_Cat,         "Concatenes two compound objects" } ;


NEWBLTN(_InstDef_Cat) {
       	OKit_Status stat ;
	OKit_List lst1, lst2 ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_LIST:
			lst1 = OKit_ListClone((OKit_List)obj1->obj) ;
			lst2 = OKit_ListClone((OKit_List)obj2->obj) ;
			obj = OKit_ListWrap(OKit_ListIns(lst1,0,lst2)) ;
			OKit_ListFree(lst2) ;
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { OKit_ObjectFree(obj1) ; OKit_ObjectFree(obj2) ; SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { OKit_ObjectFree(obj1) ; OKit_ObjectFree(obj2) ; SETSTATUS(stat) ; /* return ; */ }
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


