// ## Static OKit_Bltn Definition
// DEFINE EXEC
// INTERN Exec


NEWBLTN(_InstDef_Exec) ;


static const _OKit_Bltn _BltnDef_Exec = 
	{ "EXEC",   1, { 8    }, ~0, _InstDef_Exec,        "Execution of a portion of code" } ;


NEWBLTN(_InstDef_Exec) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
       	OKit_Status ret ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		ret = OKit_ListEval(GETSTACK(),GETNAMES(),(OKit_List)obj1->obj) ;
		if(ret.num) {
			OKit_ObjectFree(obj1) ;
			SETSTATUS(ret) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


