// ## Static OKit_Bltn Definition
// DEFINE GET
// INTERN Get


NEWBLTN(_InstDef_Get) ;


static const _OKit_Bltn _BltnDef_Get = 
	{ "GET",    2, { 1, 8 },  1, _InstDef_Get,         "Gets an object by its position in a compound object" } ;


NEWBLTN(_InstDef_Get) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	OKit_List lst ;
	unsigned long i = 0 ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_LIST:
			i = (unsigned long)*(OKit_Intg)OKit_ObjectContent(obj1) ;
			lst = (OKit_List)OKit_ObjectContent(obj2) ;
			if(i<OKit_ListLen(lst)) {
				obj = OKit_ListGet(lst,i) ;
			}
			else {
				OKit_ObjectFree(obj1) ;
				OKit_ObjectFree(obj2) ;
				stat.num = INORNG ;
				stat.msg = BltError[INORNG] ;
				SETSTATUS(stat) ;
				/* return ; */
			}
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	if(obj==NULL) { OKit_ObjectFree(obj1) ; OKit_ObjectFree(obj2) ; SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { OKit_ObjectFree(obj1) ; OKit_ObjectFree(obj2) ; SETSTATUS(stat) ; /* return ; */ }
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


