// ## Static OKit_Bltn Definition
// DEFINE HELP
// INTERN Help


NEWBLTN(_InstDef_Help) ;


static const _OKit_Bltn _BltnDef_Help = 
	{ "HELP",   1, { 36   }, ~0, _InstDef_Help,        "Returns the description of a builtin" } ;


NEWBLTN(_InstDef_Help) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Bltn blt ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_STRG:
		if(((OKit_Strg)obj1->obj)->len==0) {
			unsigned long i = 0 ;
			OKit_List lst = OKit_ListAlloc() ; 
			while(i<BltTable_Size) {
				if(OKit_ListPush(lst, OKit_StrgWrap(OKit_StrgNew(BltTable[i]->name)) )==NULL) { SETSTATUS(stat) ; /* return ; */ }
				i ++ ;
			}
			obj = OKit_ListWrap(lst) ;
			break ;
		}
		blt = OKit_BltnByName(BltTable,BltTable_Size,((OKit_Strg)obj1->obj)->chr) ;
		if(blt==NULL) {
			stat.num = NOBLTN ;
			stat.msg = BltError[NOBLTN] ;
			OKit_ObjectFree(obj1) ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		obj = OKit_StrgWrap(OKit_StrgNew(blt->desc)) ;
		break ;
	case OKit_OT_BLTN:
		blt = OKit_BltnByName(BltTable,BltTable_Size,((OKit_Bltn)obj1->obj)->name) ;
		if(blt==NULL) {
			stat.num = NOBLTN ;
			stat.msg = BltError[NOBLTN] ;
			OKit_ObjectFree(obj1) ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		obj = OKit_StrgWrap(OKit_StrgNew(blt->desc)) ;
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


