// ## Static OKit_Bltn Definition
// DEFINE IF
// INTERN If


NEWBLTN(_InstDef_If) ;


static const _OKit_Bltn _BltnDef_If = 
	{ "IF",     2, { 1, 8 }, ~0, _InstDef_If,          "'If then' control structure" } ;


NEWBLTN(_InstDef_If) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
       	OKit_Status ret ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_LIST:
			if(*(OKit_Intg)obj1->obj) {
				ret = OKit_ListEval(GETSTACK(),GETNAMES(),(OKit_List)obj2->obj) ;
				if(ret.num) {
					OKit_ObjectFree(obj1) ;
					OKit_ObjectFree(obj2) ;
					SETSTATUS(ret) ;
					/* return ; */
				}
			}
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


