// ## Static OKit_Bltn Definition
// DEFINE LOOP
// INTERN Loop


NEWBLTN(_InstDef_Loop) ;


static const _OKit_Bltn _BltnDef_Loop = 
	{ "LOOP",   1, { 8    }, ~0, _InstDef_Loop,        "Loops until code execution return false" } ;


NEWBLTN(_InstDef_Loop) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	unsigned short t ;
       	OKit_Status ret ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		t = 1 ;
		while(t) {
			ret = OKit_ListEval(GETSTACK(),GETNAMES(),(OKit_List)obj1->obj) ;
			if(ret.num) {
				OKit_ObjectFree(obj1) ;
				SETSTATUS(ret) ;
				/* return ; */
			}
			if(OKit_StackDepth(GETSTACK())<1) {
				stat.num = TOOFEWARG ;
				stat.msg = BltError[TOOFEWARG] ;
				SETSTATUS(stat) ;
				/* return ; */
			}
			t = 1 ;
			if(OKit_StackChkType(GETSTACK(),1,&t)) {
				stat.num = INVARGTYP ;
				stat.msg = BltError[INVARGTYP] ;
				SETSTATUS(stat) ;
				/* return ; */
			}
			obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
			switch(OKit_ObjectType(obj2)) {
				case OKit_OT_INTG:
					t = (*(OKit_Intg)(obj2->obj)!=0) ;
					OKit_ObjectFree(obj2) ;
					break ;
#ifdef DOCHECK
				default:
					OKit_ObjectFree(obj2) ;
					SETSTATUS(stat) ;
					/* return ; */
#endif
			}
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


