// ## Static OKit_Bltn Definition
// DEFINE OBJ
// INTERN OKit_ObjectParse


NEWBLTN(_InstDef_ObjectParse) ;


static const _OKit_Bltn _BltnDef_ObjectParse = 
	{ "OBJ",    1, { 4    },  1, _InstDef_ObjectParse, "Parse a string into objects" } ;


NEWBLTN(_InstDef_ObjectParse) {
// TODO OBJ Parser
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_List lst ;
	unsigned long off = 0 ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_STRG:
		lst = OKit_ListParse(BltTable,BltTable_Size,((OKit_Strg)obj1->obj)->chr,&off) ;
		if(lst==NULL) {
			OKit_ObjectFree(obj1) ;
			stat.num = PARSERRR ;
			stat.msg = BltError[PARSERRR] ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		obj = OKit_ListWrap(lst) ;
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


