// ## Static OKit_Bltn Definition
// DEFINE RND
// INTERN RND


NEWBLTN(_InstDef_RND) ;


static const _OKit_Bltn _BltnDef_RND = 
	{ "RND",    1, { 3    },  1, _InstDef_RND,         "Rounds a number" } ;


NEWBLTN(_InstDef_RND) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		obj = OKit_IntgWrap(OKit_IntgNew( (long)(*(OKit_Intg)obj1->obj) )) ;
		break ;
	case OKit_OT_FLTP:
		obj = OKit_IntgWrap(OKit_IntgNew( (long)(*(OKit_Fltp)obj1->obj) )) ;
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


