// ## Static OKit_Bltn Definition
// DEFINE RCLV
// INTERN RecallVar


NEWBLTN(_InstDef_RecallVar) ;


static const _OKit_Bltn _BltnDef_RecallVar = 
	{ "RCLV",   1, { 4    },  1, _InstDef_RecallVar,   "Recalls a variable's value" } ;


NEWBLTN(_InstDef_RecallVar) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_STRG:
		// HACK direct access to internals of OKit_Strg
		obj = OKit_NameSpaceGet(GETNAMES(),((OKit_Strg)obj1->obj)->chr) ;
		if(obj==NULL) {
			stat.num = NOSCHVAR ;
			stat.msg = BltError[NOSCHVAR] ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


