// ## Static OKit_Bltn Definition
// DEFINE EQL
// INTERN Same


NEWBLTN(_InstDef_Same) ;


static const _OKit_Bltn _BltnDef_Same = 
	{ "EQL",    2, { ~0,~0},  1, _InstDef_Same,        "Tests if two objects are equal" } ;


NEWBLTN(_InstDef_Same) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	unsigned long t = 0 ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	if(OKit_ObjectType(obj1)!=OKit_ObjectType(obj2)) obj = OKit_IntgWrap(OKit_IntgNew(0)) ;
	else {
		t = OKit_ObjectEqual(obj1,obj2) ;
#ifdef DOCHECK
		if(t==-1) {
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
		}
#endif
		obj = OKit_IntgWrap(OKit_IntgNew(t)) ;
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


