// ## Static OKit_Bltn Definition
// DEFINE CALV
// INTERN CallVar


NEWBLTN(_InstDef_CallVar) ;


static const _OKit_Bltn _BltnDef_CallVar = 
	{ "CALV",   1, { 4    }, ~0, _InstDef_CallVar,     "Execute a variable's content" } ;


NEWBLTN(_InstDef_CallVar) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
       	OKit_Status ret ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_STRG:
		// HACK of the OKit_Strg API
		obj2 = OKit_NameSpaceGet(GETNAMES(),((OKit_Strg)obj1->obj)->chr) ;
		if(obj2==NULL) {
			stat.num = NOSCHVAR ;
			stat.msg = BltError[NOSCHVAR] ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_LIST:
			ret = OKit_ListEval(GETSTACK(),GETNAMES(),(OKit_List)obj2->obj) ;
			if(ret.num) {
				OKit_ObjectFree(obj1) ;
				SETSTATUS(ret) ;
				/* return ; */
			}
			break ;
		default:
			OKit_ObjectFree(obj1) ;
			stat.num = INVARGTYP ;
			stat.msg = BltError[INVARGTYP] ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


