// ## Static OKit_Bltn Definition
// DEFINE ERR
// INTERN Err


NEWBLTN(_InstDef_Err) ;


static const _OKit_Bltn _BltnDef_Err = 
	{ "ERR",    2, { 1, 4 }, ~0, _InstDef_Err,         "Aborts with specified error" } ;


NEWBLTN(_InstDef_Err) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	unsigned long num = RNTERR ;
	unsigned long i = 0 ;
	static char msg[256] ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_STRG:
			num = (unsigned long)*((OKit_Intg)obj1->obj) ;
			while( (i<254) && (i<((OKit_Strg)obj2->obj)->len) ) {
				msg[i] = ((OKit_Strg)obj2->obj)->chr[i] ;
				i ++ ;
			}
			while(i<255) {
				msg[i] = 0 ;
				i ++ ;
			}
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = num ;
	stat.msg = msg ;
	printf("Died! < %lu - %s >\n",stat.num,stat.msg) ;
	SETSTATUS(stat) ;
	/* return ; */
}


