// ## Static OKit_Bltn Definition
// DEFINE GRP
// INTERN Group


NEWBLTN(_InstDef_Group) ;


static const _OKit_Bltn _BltnDef_Group = 
	{ "GRP",    1, { 1    },  1, _InstDef_Group,       "Builds a compound object" } ;


NEWBLTN(_InstDef_Group) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	unsigned long i = 0 ;
	OKit_List lst = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		lst = OKit_ListAlloc() ;
		i = *(OKit_Intg)obj1->obj ;
		if(i>OKit_StackDepth(GETSTACK())) {
			stat.num = TOOFEWARG ;
			stat.msg = BltError[TOOFEWARG] ;
			SETSTATUS(stat) ;
			/* return ; */
		}
		while(i>0) {
			obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
			if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
			if(OKit_ListUnshift(lst,obj2)==NULL) { SETSTATUS(stat) ; /* return ; */ }
			i -- ;
		}
		obj = OKit_ListWrap(lst) ;
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


