// ## Static OKit_Bltn Definition
// DEFINE GSZ
// INTERN GroupSize


NEWBLTN(_InstDef_GroupSize) ;


static const _OKit_Bltn _BltnDef_GroupSize = 
	{ "GSZ",    1, { 8    },  1, _InstDef_GroupSize,   "Size of a compound object" } ;


NEWBLTN(_InstDef_GroupSize) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_List lst = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		lst = (OKit_List)obj1->obj ;
		obj = OKit_IntgWrap(OKit_IntgNew(OKit_ListLen(lst))) ;
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;

	SETSTATUS(stat) ;
	/* return ; */
}


