// ## Static OKit_Bltn Definition
// DEFINE OR
// INTERN OR


NEWBLTN(_InstDef_OR) ;


static const _OKit_Bltn _BltnDef_OR = 
	{ "OR",     2, { 1, 1 },  1, _InstDef_OR,          "Boolean disjunction" } ;


NEWBLTN(_InstDef_OR) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_INTG:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_INTG:
			obj = OKit_IntgWrap(OKit_IntgNew( (*((OKit_Intg)obj1->obj)) || (*((OKit_Intg)obj2->obj)) )) ;
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	if(obj==NULL) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


