// ## Static OKit_Bltn Definition
// DEFINE RAIL
// INTERN Rail


NEWBLTN(_InstDef_Rail) ;


static const _OKit_Bltn _BltnDef_Rail = 
	{ "RAIL",   2, { 8, 8 },  1, _InstDef_Rail,        "Executes a block on each element in a list" } ;


NEWBLTN(_InstDef_Rail) {
       	OKit_Status stat ;
	OKit_Object obj = NULL ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
       	OKit_Status ret ;
	unsigned long l, i ;
	OKit_List lst ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_LIST:
		switch(OKit_ObjectType(obj2)) {
		case OKit_OT_LIST:
			// FIXME: execution !
			lst = OKit_ListNew() ;
			l = OKit_ListLen((OKit_List)OKit_ObjectContent(obj2)) ;
			i = 0 ;
			while(i<l) {
				OKit_StackPush(GETSTACK(),OKit_ListGet((OKit_List)OKit_ObjectContent(obj2),i)) ;
				ret = OKit_ListEval(GETSTACK(),GETNAMES(),(OKit_List)OKit_ObjectContent(obj1)) ;
				if(ret.num) {
					OKit_ObjectFree(obj1) ;
					SETSTATUS(ret) ;
					/* return ; */
				}
				if(OKit_StackDepth(GETSTACK())>0) OKit_ListPush(lst,OKit_StackPop(GETSTACK())) ;
				i ++ ;
			}
			obj = OKit_ListWrap(lst) ;
			break ;
#ifdef DOCHECK
		default:
			OKit_ObjectFree(obj1) ;
			OKit_ObjectFree(obj2) ;
			SETSTATUS(stat) ;
			/* return ; */
#endif
		}
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	if(obj==NULL) {
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
	}
	if(OKit_StackPush(GETSTACK(),obj)==-1) {
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


