// ## Static OKit_Bltn Definition
// DEFINE STOV
// INTERN StoreVar


NEWBLTN(_InstDef_StoreVar) ;


static const _OKit_Bltn _BltnDef_StoreVar = 
	{ "STOV",   2, { 4,~0 },  0, _InstDef_StoreVar,    "Stores a value in a variable" } ;


NEWBLTN(_InstDef_StoreVar) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	switch(OKit_ObjectType(obj1)) {
	case OKit_OT_STRG:
		// HACK direct access to internals of OKit_Strg
		obj2 = OKit_NameSpaceSet(GETNAMES(),((OKit_Strg)obj1->obj)->chr,obj2) ;
#ifdef DOCHECK
		if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
		break ;
#ifdef DOCHECK
	default:
		OKit_ObjectFree(obj1) ;
		OKit_ObjectFree(obj2) ;
		SETSTATUS(stat) ;
		/* return ; */
#endif
	}
	OKit_ObjectFree(obj1) ;
	OKit_ObjectFree(obj2) ;
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


