// ## Static OKit_Bltn Definition
// DEFINE SWAP
// INTERN Swap


NEWBLTN(_InstDef_Swap) ;


static const _OKit_Bltn _BltnDef_Swap = 
	{ "SWAP",   2, { ~0,~0},  2, _InstDef_Swap,        "Swaps the two first objects on stack" } ;


NEWBLTN(_InstDef_Swap) {
       	OKit_Status stat ;
	OKit_Object obj1 = NULL ;
	OKit_Object obj2 = NULL ;
	stat.num = RNTERR ;
	stat.msg = BltError[RNTERR] ;
	obj1 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj1==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	obj2 = OKit_StackPop(GETSTACK()) ;
#ifdef DOCHECK
	if(obj2==NULL) { SETSTATUS(stat) ; /* return ; */ }
#endif
	if(OKit_StackPush(GETSTACK(),obj1)==-1) { SETSTATUS(stat) ; /* return ; */ }
	if(OKit_StackPush(GETSTACK(),obj2)==-1) { SETSTATUS(stat) ; /* return ; */ }
	stat.num = OK ;
	stat.msg = BltError[OK] ;
	SETSTATUS(stat) ;
	/* return ; */
}


